Index: include/avr/iotn43u.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotn43u.h,v
retrieving revision 1.10
diff -u -r1.10 iotn43u.h
--- include/avr/iotn43u.h	11 Feb 2009 17:53:38 -0000	1.10
+++ include/avr/iotn43u.h	26 Mar 2009 20:10:36 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2007 Atmel Corporation
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -476,48 +477,63 @@
 /* Interrupt vector 0 is the reset vector. */
 
 /* External Interrupt Request 0 */
+#define INT0_num            1
 #define INT0_vect           _VECTOR(1)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num          2
 #define PCINT0_vect         _VECTOR(2)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num          3
 #define PCINT1_vect         _VECTOR(3)
 
 /* Watchdog Time-out */
+#define WDT_num             4
 #define WDT_vect            _VECTOR(4)
 
 /* Timer/Counter1 Compare Match A */
+#define TIM1_COMPA_num      5
 #define TIM1_COMPA_vect     _VECTOR(5)
 
 /* Timer/Counter1 Compare Match B */
+#define TIM1_COMPB_num      6
 #define TIM1_COMPB_vect     _VECTOR(6)
 
 /* Timer/Counter1 Overflow */
+#define TIM1_OVF_num        7
 #define TIM1_OVF_vect       _VECTOR(7)
 
 /* Timer/Counter0 Compare Match A */
+#define TIM0_COMPA_num      8
 #define TIM0_COMPA_vect     _VECTOR(8)
 
 /* Timer/Counter0 Compare Match B */
+#define TIM0_COMPB_num      9
 #define TIM0_COMPB_vect     _VECTOR(9)
 
 /* Timer/Counter0 Overflow */
+#define TIM0_OVF_num        10
 #define TIM0_OVF_vect       _VECTOR(10)
 
 /* Analog Comparator */
+#define ANA_COMP_num        11
 #define ANA_COMP_vect       _VECTOR(11)
 
 /* ADC Conversion Complete */
+#define ADC_num             12
 #define ADC_vect            _VECTOR(12)
 
 /* EEPROM Ready */
+#define EE_RDY_num          13
 #define EE_RDY_vect         _VECTOR(13)
 
 /* USI START */
+#define USI_START_num       14
 #define USI_START_vect      _VECTOR(14)
 
 /* USI Overflow */
+#define USI_OVF_num         15
 #define USI_OVF_vect        _VECTOR(15)
 
 #define _VECTORS_SIZE 32
@@ -572,4 +588,281 @@
 #define SIGNATURE_2 0x0C
 
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_DI  	DDRA
+#define PORT_DI 	PORTA
+#define PIN_DI  	PINA
+#define DI_IDX  	0
+
+#define DDR_SDA  	DDRA
+#define PORT_SDA 	PORTA
+#define PIN_SDA  	PINA
+#define SDA_IDX  	0
+
+#define DDR_PCINT0  	DDRA
+#define PORT_PCINT0 	PORTA
+#define PIN_PCINT0  	PINA
+#define PCINT0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_DO  	DDRA
+#define PORT_DO 	PORTA
+#define PIN_DO  	PINA
+#define DO_IDX  	1
+
+#define DDR_PCINT1  	DDRA
+#define PORT_PCINT1 	PORTA
+#define PIN_PCINT1  	PINA
+#define PCINT1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_INT1  	DDRA
+#define PORT_INT1 	PORTA
+#define PIN_INT1  	PINA
+#define INT1_IDX  	2
+
+#define DDR_USCK  	DDRA
+#define PORT_USCK 	PORTA
+#define PIN_USCK  	PINA
+#define USCK_IDX  	2
+
+#define DDR_SCL  	DDRA
+#define PORT_SCL 	PORTA
+#define PIN_SCL  	PINA
+#define SCL_IDX  	2
+
+#define DDR_PCINT2  	DDRA
+#define PORT_PCINT2 	PORTA
+#define PIN_PCINT2  	PINA
+#define PCINT2_IDX  	2
+
+#define DDR_PCINT3  	DDRA
+#define PORT_PCINT3 	PORTA
+#define PIN_PCINT3  	PINA
+#define PCINT3_IDX  	3
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	4
+
+#define DDR_ICP0  	DDRA
+#define PORT_ICP0 	PORTA
+#define PIN_ICP0  	PINA
+#define ICP0_IDX  	4
+
+#define DDR_PCINT4  	DDRA
+#define PORT_PCINT4 	PORTA
+#define PIN_PCINT4  	PINA
+#define PCINT4_IDX  	4
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	5
+
+#define DDR_AIN2  	DDRA
+#define PORT_AIN2 	PORTA
+#define PIN_AIN2  	PINA
+#define AIN2_IDX  	5
+
+#define DDR_PCINT5  	DDRA
+#define PORT_PCINT5 	PORTA
+#define PIN_PCINT5  	PINA
+#define PCINT5_IDX  	5
+
+#define DDR_ADC5  	DDRA
+#define PORT_ADC5 	PORTA
+#define PIN_ADC5  	PINA
+#define ADC5_IDX  	6
+
+#define DDR_AIN0  	DDRA
+#define PORT_AIN0 	PORTA
+#define PIN_AIN0  	PINA
+#define AIN0_IDX  	6
+
+#define DDR_PCINT6  	DDRA
+#define PORT_PCINT6 	PORTA
+#define PIN_PCINT6  	PINA
+#define PCINT6_IDX  	6
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	7
+
+#define DDR_AIN1  	DDRA
+#define PORT_AIN1 	PORTA
+#define PIN_AIN1  	PINA
+#define AIN1_IDX  	7
+
+#define DDR_PCINT7  	DDRA
+#define PORT_PCINT7 	PORTA
+#define PIN_PCINT7  	PINA
+#define PCINT7_IDX  	7
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	0
+
+#define DDR_DI  	DDRB
+#define PORT_DI 	PORTB
+#define PIN_DI  	PINB
+#define DI_IDX  	0
+
+#define DDR_SDA  	DDRB
+#define PORT_SDA 	PORTB
+#define PIN_SDA  	PINB
+#define SDA_IDX  	0
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	0
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	1
+
+#define DDR_DO  	DDRB
+#define PORT_DO 	PORTB
+#define PIN_DO  	PINB
+#define DO_IDX  	1
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	1
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	2
+
+#define DDR_USCK  	DDRB
+#define PORT_USCK 	PORTB
+#define PIN_USCK  	PINB
+#define USCK_IDX  	2
+
+#define DDR_SCL  	DDRB
+#define PORT_SCL 	PORTB
+#define PIN_SCL  	PINB
+#define SCL_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	2
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	3
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_ADC7  	DDRB
+#define PORT_ADC7 	PORTB
+#define PIN_ADC7  	PINB
+#define ADC7_IDX  	4
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_OC1D  	DDRB
+#define PORT_OC1D 	PORTB
+#define PIN_OC1D  	PINB
+#define OC1D_IDX  	4
+
+#define DDR_CLKI  	DDRB
+#define PORT_CLKI 	PORTB
+#define PIN_CLKI  	PINB
+#define CLKI_IDX  	4
+
+#define DDR_ADC8  	DDRB
+#define PORT_ADC8 	PORTB
+#define PIN_ADC8  	PINB
+#define ADC8_IDX  	5
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_OC1D  	DDRB
+#define PORT_OC1D 	PORTB
+#define PIN_OC1D  	PINB
+#define OC1D_IDX  	5
+
+#define DDR_CKLO  	DDRB
+#define PORT_CKLO 	PORTB
+#define PIN_CKLO  	PINB
+#define CKLO_IDX  	5
+
+#define DDR_ADC9  	DDRB
+#define PORT_ADC9 	PORTB
+#define PIN_ADC9  	PINB
+#define ADC9_IDX  	6
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	6
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_ADC10  	DDRB
+#define PORT_ADC10 	PORTB
+#define PIN_ADC10  	PINB
+#define ADC10_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+
 #endif /* _AVR_IOTN43U_H_ */
Index: include/avr/iotn28.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotn28.h,v
retrieving revision 1.14
diff -u -r1.14 iotn28.h
--- include/avr/iotn28.h	17 Oct 2008 23:22:45 -0000	1.14
+++ include/avr/iotn28.h	26 Mar 2009 20:10:36 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -92,22 +93,27 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Low-level Input on Port B */
+#define LOWLEVEL_IO_PINS_num 		3
 #define LOWLEVEL_IO_PINS_vect		_VECTOR(3)
 #define SIG_PIN				_VECTOR(3)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			4
 #define TIMER0_OVF_vect			_VECTOR(4)
 #define SIG_OVERFLOW0			_VECTOR(4)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			5
 #define ANA_COMP_vect			_VECTOR(5)
 #define SIG_COMPARATOR			_VECTOR(5)
 
@@ -272,4 +278,36 @@
 #define SIGNATURE_2 0x07
 
 
+/* Device Pin Definitions */
+#define DDR_IR  	DDRA
+#define PORT_IR 	PORTA
+#define PIN_IR  	PINA
+#define IR_IDX  	2
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	0
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	1
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	2
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	3
+
+#define DDR_INT1  	DDRB
+#define PORT_INT1 	PORTB
+#define PIN_INT1  	PINB
+#define INT1_IDX  	4
+
+
 #endif /* _AVR_IOTN28_H_ */
Index: include/avr/iom103.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom103.h,v
retrieving revision 1.12
diff -u -r1.12 iom103.h
--- include/avr/iom103.h	13 Aug 2008 23:29:50 -0000	1.12
+++ include/avr/iom103.h	26 Mar 2009 20:10:25 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -224,94 +225,117 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* External Interrupt 3 */
+#define INT3_num 			4
 #define INT3_vect			_VECTOR(4)
 #define SIG_INTERRUPT3			_VECTOR(4)
 
 /* External Interrupt 4 */
+#define INT4_num 			5
 #define INT4_vect			_VECTOR(5)
 #define SIG_INTERRUPT4			_VECTOR(5)
 
 /* External Interrupt 5 */
+#define INT5_num 			6
 #define INT5_vect			_VECTOR(6)
 #define SIG_INTERRUPT5			_VECTOR(6)
 
 /* External Interrupt 6 */
+#define INT6_num 			7
 #define INT6_vect			_VECTOR(7)
 #define SIG_INTERRUPT6			_VECTOR(7)
 
 /* External Interrupt 7 */
+#define INT7_num 			8
 #define INT7_vect			_VECTOR(8)
 #define SIG_INTERRUPT7			_VECTOR(8)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		9
 #define TIMER2_COMP_vect		_VECTOR(9)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(9)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			10
 #define TIMER2_OVF_vect			_VECTOR(10)
 #define SIG_OVERFLOW2			_VECTOR(10)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		11
 #define TIMER1_CAPT_vect		_VECTOR(11)
 #define SIG_INPUT_CAPTURE1		_VECTOR(11)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		12
 #define TIMER1_COMPA_vect		_VECTOR(12)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(12)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		13
 #define TIMER1_COMPB_vect		_VECTOR(13)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(13)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			14
 #define TIMER1_OVF_vect			_VECTOR(14)
 #define SIG_OVERFLOW1			_VECTOR(14)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		15
 #define TIMER0_COMP_vect		_VECTOR(15)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(15)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			16
 #define TIMER0_OVF_vect			_VECTOR(16)
 #define SIG_OVERFLOW0			_VECTOR(16)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			17
 #define SPI_STC_vect			_VECTOR(17)
 #define SIG_SPI				_VECTOR(17)
 
 /* UART, Rx Complete */
+#define UART_RX_num 			18
 #define UART_RX_vect			_VECTOR(18)
 #define SIG_UART_RECV			_VECTOR(18)
 
 /* UART Data Register Empty */
+#define UART_UDRE_num 			19
 #define UART_UDRE_vect			_VECTOR(19)
 #define SIG_UART_DATA			_VECTOR(19)
 
 /* UART, Tx Complete */
+#define UART_TX_num 			20
 #define UART_TX_vect			_VECTOR(20)
 #define SIG_UART_TRANS			_VECTOR(20)
 
 /* ADC Conversion Complete */
+#define ADC_num 			21
 #define ADC_vect			_VECTOR(21)
 #define SIG_ADC				_VECTOR(21)
 
 /* EEPROM Ready */
+#define EE_READY_num 			22
 #define EE_READY_vect			_VECTOR(22)
 #define SIG_EEPROM_READY		_VECTOR(22)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		23
 #define ANALOG_COMP_vect		_VECTOR(23)
 #define SIG_COMPARATOR			_VECTOR(23)
 
@@ -672,4 +696,256 @@
 #define SIGNATURE_2 0x01
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	0
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	1
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	2
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	3
+
+#define DDR_OC0  	DDRB
+#define PORT_OC0 	PORTB
+#define PIN_OC0  	PINB
+#define OC0_IDX  	4
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	5
+
+#define DDR_PWM1A  	DDRB
+#define PORT_PWM1A 	PORTB
+#define PIN_PWM1A  	PINB
+#define PWM1A_IDX  	5
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	6
+
+#define DDR_PWM1B  	DDRB
+#define PORT_PWM1B 	PORTB
+#define PIN_PWM1B  	PINB
+#define PWM1B_IDX  	6
+
+#define DDR_OC2  	DDRB
+#define PORT_OC2 	PORTB
+#define PIN_OC2  	PINB
+#define OC2_IDX  	7
+
+#define DDR_OC1C  	DDRB
+#define PORT_OC1C 	PORTB
+#define PIN_OC1C  	PINB
+#define OC1C_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	0
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	1
+
+#define DDR_INT2  	DDRD
+#define PORT_INT2 	PORTD
+#define PIN_INT2  	PIND
+#define INT2_IDX  	2
+
+#define DDR_INT3  	DDRD
+#define PORT_INT3 	PORTD
+#define PIN_INT3  	PIND
+#define INT3_IDX  	3
+
+#define DDR_IC1  	DDRD
+#define PORT_IC1 	PORTD
+#define PIN_IC1  	PIND
+#define IC1_IDX  	4
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	6
+
+#define DDR_T2  	DDRD
+#define PORT_T2 	PORTD
+#define PIN_T2  	PIND
+#define T2_IDX  	7
+
+#define DDR_RXD0  	DDRE
+#define PORT_RXD0 	PORTE
+#define PIN_RXD0  	PINE
+#define RXD0_IDX  	0
+
+#define DDR_TXD0  	DDRE
+#define PORT_TXD0 	PORTE
+#define PIN_TXD0  	PINE
+#define TXD0_IDX  	1
+
+#define DDR_AC_P  	DDRE
+#define PORT_AC_P 	PORTE
+#define PIN_AC_P  	PINE
+#define AC_P_IDX  	2
+
+#define DDR_AC_N  	DDRE
+#define PORT_AC_N 	PORTE
+#define PIN_AC_N  	PINE
+#define AC_N_IDX  	3
+
+#define DDR_INT4  	DDRE
+#define PORT_INT4 	PORTE
+#define PIN_INT4  	PINE
+#define INT4_IDX  	4
+
+#define DDR_INT5  	DDRE
+#define PORT_INT5 	PORTE
+#define PIN_INT5  	PINE
+#define INT5_IDX  	5
+
+#define DDR_INT6  	DDRE
+#define PORT_INT6 	PORTE
+#define PIN_INT6  	PINE
+#define INT6_IDX  	6
+
+#define DDR_INT7  	DDRE
+#define PORT_INT7 	PORTE
+#define PIN_INT7  	PINE
+#define INT7_IDX  	7
+
+#define DDR_ADC0  	DDRF
+#define PORT_ADC0 	PORTF
+#define PIN_ADC0  	PINF
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRF
+#define PORT_ADC1 	PORTF
+#define PIN_ADC1  	PINF
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRF
+#define PORT_ADC2 	PORTF
+#define PIN_ADC2  	PINF
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRF
+#define PORT_ADC3 	PORTF
+#define PIN_ADC3  	PINF
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRF
+#define PORT_ADC4 	PORTF
+#define PIN_ADC4  	PINF
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRF
+#define PORT_ADC5 	PORTF
+#define PIN_ADC5  	PINF
+#define ADC5_IDX  	5
+
+#define DDR_ADC6  	DDRF
+#define PORT_ADC6 	PORTF
+#define PIN_ADC6  	PINF
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRF
+#define PORT_ADC7 	PORTF
+#define PIN_ADC7  	PINF
+#define ADC7_IDX  	7
+
+
 #endif /* _AVR_IOM103_H_ */
Index: include/avr/iotnx5.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotnx5.h,v
retrieving revision 1.9
diff -u -r1.9 iotnx5.h
--- include/avr/iotnx5.h	7 Feb 2009 19:24:23 -0000	1.9
+++ include/avr/iotnx5.h	26 Mar 2009 20:10:37 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2005,2007 Anatoly Sokolov
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -350,67 +351,234 @@
 /* Interrupt vectors */
 /* Interrupt vector 0 is the reset vector. */
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* Pin change Interrupt Request 0 */
+#define PCINT0_num 			2
 #define PCINT0_vect			_VECTOR(2)
 #define SIG_PIN_CHANGE			_VECTOR(2)
 
 /* Timer/Counter1 Compare Match 1A */
+#define TIM1_COMPA_num 			3
 #define TIM1_COMPA_vect			_VECTOR(3)
+#define TIMER1_COMPA_num 		3
 #define TIMER1_COMPA_vect		_VECTOR(3)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(3)
 
 /* Timer/Counter1 Overflow */
+#define TIM1_OVF_num 			4
 #define TIM1_OVF_vect			_VECTOR(4)
+#define TIMER1_OVF_num 			4
 #define TIMER1_OVF_vect			_VECTOR(4)
 #define SIG_OVERFLOW1			_VECTOR(4)
 
 /* Timer/Counter0 Overflow */
+#define TIM0_OVF_num 			5
 #define TIM0_OVF_vect			_VECTOR(5)
+#define TIMER0_OVF_num 			5
 #define TIMER0_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW0			_VECTOR(5)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			6
 #define EE_RDY_vect			_VECTOR(6)
 #define SIG_EEPROM_READY		_VECTOR(6)
 
 /* Analog comparator */
+#define ANA_COMP_num 			7
 #define ANA_COMP_vect			_VECTOR(7)
 #define SIG_COMPARATOR			_VECTOR(7)
 
 /* ADC Conversion ready */
+#define ADC_num 			8
 #define ADC_vect			_VECTOR(8)
 #define SIG_ADC				_VECTOR(8)
 
 /* Timer/Counter1 Compare Match B */
+#define TIM1_COMPB_num 			9
 #define TIM1_COMPB_vect			_VECTOR(9)
+#define TIMER1_COMPB_num 		9
 #define TIMER1_COMPB_vect		_VECTOR(9)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(9)
 
 /* Timer/Counter0 Compare Match A */
+#define TIM0_COMPA_num 			10
 #define TIM0_COMPA_vect			_VECTOR(10)
+#define TIMER0_COMPA_num 		10
 #define TIMER0_COMPA_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0A		_VECTOR(10)
 
 /* Timer/Counter0 Compare Match B */
+#define TIM0_COMPB_num 			11
 #define TIM0_COMPB_vect			_VECTOR(11)
+#define TIMER0_COMPB_num 		11
 #define TIMER0_COMPB_vect		_VECTOR(11)
 #define SIG_OUTPUT_COMPARE0B		_VECTOR(11)
 
 /* Watchdog Time-out */
+#define WDT_num 			12
 #define WDT_vect			_VECTOR(12)
 #define SIG_WATCHDOG_TIMEOUT		_VECTOR(12)
 
 /* USI START */
+#define USI_START_num 			13
 #define USI_START_vect			_VECTOR(13)
 #define SIG_USI_START			_VECTOR(13)
 
 /* USI Overflow */
+#define USI_OVF_num 			14
 #define USI_OVF_vect			_VECTOR(14)
 #define SIG_USI_OVERFLOW		_VECTOR(14)
 
 #define _VECTORS_SIZE 30
 
+/* Device Pin Definitions */
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	0
+
+#define DDR_DI  	DDRB
+#define PORT_DI 	PORTB
+#define PIN_DI  	PINB
+#define DI_IDX  	0
+
+#define DDR_SDA  	DDRB
+#define PORT_SDA 	PORTB
+#define PIN_SDA  	PINB
+#define SDA_IDX  	0
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	0
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	0
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	0
+
+#define DDR_PCINT0  	DDRB
+#define PORT_PCINT0 	PORTB
+#define PIN_PCINT0  	PINB
+#define PCINT0_IDX  	0
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	1
+
+#define DDR_DO  	DDRB
+#define PORT_DO 	PORTB
+#define PIN_DO  	PINB
+#define DO_IDX  	1
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	1
+
+#define DDR_OC0B  	DDRB
+#define PORT_OC0B 	PORTB
+#define PIN_OC0B  	PINB
+#define OC0B_IDX  	1
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	1
+
+#define DDR_PCINT1  	DDRB
+#define PORT_PCINT1 	PORTB
+#define PIN_PCINT1  	PINB
+#define PCINT1_IDX  	1
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	2
+
+#define DDR_USCK  	DDRB
+#define PORT_USCK 	PORTB
+#define PIN_USCK  	PINB
+#define USCK_IDX  	2
+
+#define DDR_SCL  	DDRB
+#define PORT_SCL 	PORTB
+#define PIN_SCL  	PINB
+#define SCL_IDX  	2
+
+#define DDR_ADC1  	DDRB
+#define PORT_ADC1 	PORTB
+#define PIN_ADC1  	PINB
+#define ADC1_IDX  	2
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	2
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	2
+
+#define DDR_PCINT2  	DDRB
+#define PORT_PCINT2 	PORTB
+#define PIN_PCINT2  	PINB
+#define PCINT2_IDX  	2
+
+#define DDR_ADC3  	DDRB
+#define PORT_ADC3 	PORTB
+#define PIN_ADC3  	PINB
+#define ADC3_IDX  	3
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	3
+
+#define DDR_PCINT4  	DDRB
+#define PORT_PCINT4 	PORTB
+#define PIN_PCINT4  	PINB
+#define PCINT4_IDX  	3
+
+#define DDR_ADC2  	DDRB
+#define PORT_ADC2 	PORTB
+#define PIN_ADC2  	PINB
+#define ADC2_IDX  	4
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	4
+
+#define DDR_PCINT3  	DDRB
+#define PORT_PCINT3 	PORTB
+#define PIN_PCINT3  	PINB
+#define PCINT3_IDX  	4
+
+#define DDR_ADC0  	DDRB
+#define PORT_ADC0 	PORTB
+#define PIN_ADC0  	PINB
+#define ADC0_IDX  	5
+
+#define DDR_PCINT5  	DDRB
+#define PORT_PCINT5 	PORTB
+#define PIN_PCINT5  	PINB
+#define PCINT5_IDX  	5
+
+#define DDR_dW  	DDRB
+#define PORT_dW 	PORTB
+#define PIN_dW  	PINB
+#define dW_IDX  	5
+
+
 #endif /* _AVR_IOTNX5_H_ */
